# DCU ECU Alerts and Diagnostics
# Highly Confidential and Proprietary Zoox Information. Copyright (c) Zoox.

component: 'DCU'
source_enum: kEmuDCU
namespace: zoox::dcu
can_messages:
  - status_msg: DCU1_alertStatus
    log_msg: DCU1_alertLog
  - status_msg: DCU2_alertStatus
    log_msg: DCU2_alertLog
can_import: firmware/common/can/generated/vh6/vh6b/dcu.h
can_namespace: vh6b
faults:
  - id: 0
    name: TluCurrentLow
    severity: ERROR
    description: Top latch underlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 1
    name: TluCurrentHigh
    severity: ERROR
    description: Top latch underlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 2
    name: TluBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 3
    name: TluSwitchInvalid
    severity: ERROR
    description: Top latch underlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 4
    name: TluTimeout
    severity: ERROR
    description: Top latch underlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 5
    name: SluCurrentLow
    severity: ERROR
    description: Side latch underlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 6
    name: SluCurrentHigh
    severity: ERROR
    description: Side latch underlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 7
    name: SluBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 8
    name: SluSwitchInvalid
    severity: ERROR
    description: Side latch underlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 9
    name: SluTimeout
    severity: ERROR
    description: Side latch underlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 10
    name: BluCurrentLow
    severity: ERROR
    description: Bottom latch underlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 11
    name: BluCurrentHigh
    severity: ERROR
    description: Bottom latch underlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 12
    name: BluBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 13
    name: BluSwitchInvalid
    severity: ERROR
    description: Bottom latch underlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 14
    name: BluTimeout
    severity: ERROR
    description: Bottom latch underlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 15
    name: TloCurrentLow
    severity: ERROR
    description: Top latch overlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 16
    name: TloCurrentHigh
    severity: ERROR
    description: Top latch overlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 17
    name: TloBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 18
    name: TloSwitchInvalid
    severity: ERROR
    description: Top latch overlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 19
    name: TloTimeout
    severity: ERROR
    description: Top latch overlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 20
    name: SloCurrentLow
    severity: ERROR
    description: Side latch overlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 21
    name: SloCurrentHigh
    severity: ERROR
    description: Side latch overlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 22
    name: SloBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 23
    name: SloSwitchInvalid
    severity: ERROR
    description: Side latch overlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 24
    name: SloTimeout
    severity: ERROR
    description: Side latch overlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 25
    name: BloCurrentLow
    severity: ERROR
    description: Bottom latch overlapping door motor current lower than expected.
    troubleshooting_steps: Inspect latch harnessing.
  - id: 26
    name: BloCurrentHigh
    severity: ERROR
    description: Bottom latch overlapping door motor current higher than expected.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 27
    name: BloBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect latch unit. Replace DCU if persists.
  - id: 28
    name: BloSwitchInvalid
    severity: ERROR
    description: Bottom latch overlapping door position switch state is invalid.
    troubleshooting_steps: Inspect latch harnessing. Inspect latch unit.
  - id: 29
    name: BloTimeout
    severity: ERROR
    description: Bottom latch overlapping door operation took longer than expected to compelete.
    troubleshooting_steps: Ensure cinching/release path clear. Inspect latch unit.
  - id: 30
    name: UnderDriCurrentLow
    severity: ERROR
    description: Underlapping door primary drive current lower than expected.
    troubleshooting_steps: Inspect primary drive harness.
  - id: 31
    name: UnderDriBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect primary drive unit. Replace DCU if persists.
  - id: 32
    name: UnderDriEncMissing
    severity: ERROR
    description: Underlapping door primary drive encoder rate lower than expected.
    troubleshooting_steps: Inspect primary drive harness.
  - id: 33
    name: OverDriCurrentLow
    severity: ERROR
    description: Overlapping door primary drive current lower than expected.
    troubleshooting_steps: Inspect primary drive harness.
  - id: 34
    name: OverDriBridgeFault
    severity: ERROR
    description: DCU hardware H bridge in fault state.
    troubleshooting_steps: Inspect primary drive unit. Replace DCU if persists.
  - id: 35
    name: OverDriEncMissing
    severity: ERROR
    description: Overlapping door primary drive encoder rate lower than expected.
    troubleshooting_steps: Inspect primary drive harness.
  - id: 36
    name: EmuControlStale
    severity: ERROR
    description: Not reciving expected control messages from EMU.
    troubleshooting_steps: Confirm EMU body manager is running.
  - id: 37
    name: IrCurtainStale
    severity: WARNING
    description: IR Curtain not reporting on LIN bus.
    troubleshooting_steps: Inspect ir curtain harness.
  - id: 38
    name: EmuRawImuStale
    severity: WARNING
    description: Not reciving expected IMU messages from EMU.
    troubleshooting_steps: Confirm EMU south gateway is running.
  - id: 39
    name: FlashOpError
    severity: WARNING
    description: DCU failed to perform flash memory operation.
    troubleshooting_steps: Raise issue with firmware support. Replace DCU if persists.
  - id: 40
    name: BdyCanBusError
    severity: WARNING
    description: DCU detected a BDY CAN bus error.
    troubleshooting_steps: Inspect DCU harness. Reduce bus traffic.
  - id: 41
    name: BdyCanTxError
    severity: WARNING
    description: DCU encountered a firmware error transmiting a CAN message.
    troubleshooting_steps: Confirm BDY CAN bus integrity. Raise issue with support team if persistant.
  - id: 42
    name: BdyCanRxError
    severity: WARNING
    description: DCU encountered a firmware error reciving a CAN message.
    troubleshooting_steps: Confirm BDY CAN bus integrity. Raise issue with support team if persistant.
  - id: 43
    name: Lin1BusError
    severity: WARNING
    description: DCU encountered an error with the LIN bus.
    troubleshooting_steps: Inspect DCU harness.
  - id: 44
    name: Lin1DriverAssert
    severity: WARNING
    description: DCU encountered a firmware error with the LIN driver.
    troubleshooting_steps: Raise issue with firmware support.
  - id: 45
    name: AppEarlyInitFailure
    severity: WARNING
    description: DCU encountered a firmware error during early initialization.
    troubleshooting_steps: Raise issue with firmware support.
  - id: 46
    name: AppInitFailure
    severity: WARNING
    description: DCU encountered a firmware error during initialization.
    troubleshooting_steps: Raise issue with firmware support.
  - id: 47
    name: WatchdogReset
    severity: INFO
    description: DCU reset due to watchdog.
    troubleshooting_steps: Potentially expected. Raise issue with firmware support if seen in association with rapid resets.
  - id: 48
    name: LowVoltageReset
    severity: INFO
    description: DCU reset due to low voltage.
    troubleshooting_steps: Potentially expected. Check power if seen in association with rapid resets.
  - id: 49
    name: PowerOnReset
    severity: INFO
    description: DCU reset due to due to bootup.
  - id: 50
    name: SoftwareReset
    severity: INFO
    description: DCU reset due to due to software.
  - id: 51
    name: ExternalReset
    severity: INFO
    description: DCU reset due to due to external source.
  - id: 52
    name: AnimationDataInvalid
    severity: WARNING
    description: Animation data loaded on calibration region not successfully read by DCU.
    troubleshooting_steps: Reflash calibration region with known good binary matching DCU firmware version.
  - id: 53
    name: CalRegionInvalid
    severity: ERROR
    description: DCU calibration region format does not match DCU expecation.
    troubleshooting_steps: Reflash calibration region with known good binary matching DCU firmware version.
  - id: 54
    name: EmuDynamicsStale
    severity: WARNING
    description: Not reciving expected vehicle dynamics messages from EMU.
    troubleshooting_steps: Raise issue with firmware support.
  - id: 55
    name: PathDataInvalid
    severity: ERROR
    description: Path motion data loaded on calibration region not successfully read by DCU or failed sanity checks.
    troubleshooting_steps: Reflash calibration region with known good binary matching DCU firmware version.
  - id: 56
    name: EmuRawImuInvalid
    severity: WARNING
    description: IMU data sent by EMU not available or marked invalid.
    troubleshooting_steps: Confirm IMU calibrated and sending valid data. Raise issue with firmware support.
